#define PIN_LED (13) // INDICATOR
long int uptime = 0;
long int old_uptime = 0;
String inData;
#define TOTAL_OUTPUTS (8)
#define TOTAL_INPUTS (8)
int outputPins[TOTAL_OUTPUTS] = {5,6,7,8,11,10,12,9};
int inputPins[TOTAL_INPUTS] = {3,4,15,14,18,19,16,17};
int directLinkedPins[TOTAL_INPUTS] = {5,6,7,8,11,10,12,9};
int inputPinsStatus[TOTAL_OUTPUTS];
void setup()
{
pinMode(PIN_LED,OUTPUT);
Serial.begin(9600);
Serial.print("Initializing inputs ... ");
int i;
for (i = 0; i < TOTAL_INPUTS; i = i + 1) {
pinMode(inputPins[i],INPUT);
inputPinsStatus[i]=digitalRead(inputPins[i]);
}
Serial.println("DONE");
Serial.print("Initializing outputs ... ");
for (i = 0; i < TOTAL_OUTPUTS; i = i + 1) {
turnOffPin(outputPins[i]);
pinMode(outputPins[i],OUTPUT);
turnOffPin(outputPins[i]);
}
Serial.println("DONE");
}
void blinking(int count) {
for(int i=0;i<count;i++) {
digitalWrite(PIN_LED, HIGH);
delay(1000);
digitalWrite(PIN_LED, LOW);
delay(1000);
}
}
void turnOnPin(int number) {
Serial.print("OUT");
Serial.print(number);
Serial.println(" set to 1");
digitalWrite(number, HIGH);
}
void turnOffPin(int number) {
Serial.print("OUT");
Serial.print(number);
Serial.println(" set to 0");
digitalWrite(number, LOW);
}
void loop() {
int i;
for (i = 0; i < TOTAL_INPUTS; i = i + 1) {
int currentStatus=digitalRead(inputPins[i]);
if (currentStatus!=inputPinsStatus[i]) {
delay(100); // de-bounce delay
int currentStatusUpdated=digitalRead(inputPins[i]);
if (currentStatusUpdated==currentStatus) {
inputPinsStatus[i]=currentStatus;
Serial.print("IN");
Serial.print(i);
Serial.print(" set to ");
Serial.println(currentStatus);
if (directLinkedPins[i]!=0 && currentStatus==LOW) {
turnOnPin(directLinkedPins[i]);
}
if (directLinkedPins[i]!=0 && currentStatus==HIGH) {
turnOffPin(directLinkedPins[i]);
}
}
}
}
if (Serial.available()) {
char c=Serial.read();
if (c == '\n' || c == ';')
{
Serial.println(inData);
int commandProcessed=0;
if (inData.startsWith("turnon")) {
commandProcessed=1;
inData.replace("turnon","");
turnOnPin(outputPins[inData.toInt()]);
}
if (inData.startsWith("turnoff")) {
commandProcessed=1;
inData.replace("turnoff","");
turnOffPin(outputPins[inData.toInt()]);
}
if (inData.startsWith("status")) {
commandProcessed=1;
inData.replace("status","");
int currentStatus=digitalRead(inData.toInt());
Serial.println(currentStatus);
}
if (commandProcessed==0) {
Serial.print("Unknown command: ");
Serial.println(inData);
}
inData="";
Serial.flush();
} else {
inData += (c);
}
}
}
